diff --git a/common/image-android-dt.c b/common/image-android-dt.c
new file mode 100644
index 0000000000..f218db06bb
--- /dev/null
+++ b/common/image-android-dt.c
@@ -0,0 +1,134 @@
+/*
+ * (C) Copyright 2018 Linaro Ltd.
+ * Sam Protsenko <semen.protsenko@linaro.org>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+
+#include <image-android-dt.h>
+#include <common.h>
+#include <linux/libfdt_env.h>
+#include <linux/libfdt.h>
+
+/**
+ * Check if image header is correct.
+ *
+ * @param hdr Address to image header
+ * @return true if header is correct or false if header is incorrect
+ */
+bool android_dt_check_header(const struct dt_table_header *hdr)
+{
+	return fdt32_to_cpu(hdr->magic) == DT_TABLE_MAGIC;
+}
+
+/**
+ * Get the address of FDT (dtb or dtbo) in memory by its index in image.
+ *
+ * @param hdr Address to image header
+ * @param index Index of desired FDT in image (starting from 0)
+ * @param[out] addr If not null, will contain address to specified FDT
+ * @param[out] size If not NULL, will contain size of specified FDT
+ *
+ * @return true on success or false on error
+ */
+bool android_dt_get_fdt_by_index(const struct dt_table_header *hdr,
+				 u32 index, ulong *addr, u32 *size)
+{
+	const struct dt_table_entry *e;
+	u32 entry_count = fdt32_to_cpu(hdr->dt_entry_count);
+	u32 entries_offset = fdt32_to_cpu(hdr->dt_entries_offset);
+	u32 entry_size = fdt32_to_cpu(hdr->dt_entry_size);
+	u32 dt_offset, dt_size;
+
+	if (index > entry_count) {
+		printf("Error: index > dt_entry_count (%u > %u)\n", index,
+		       entry_count);
+		return false;
+	}
+
+	e = (const struct dt_table_entry *)((ulong)hdr + entries_offset
+			+ index * entry_size);
+	dt_offset = fdt32_to_cpu(e->dt_offset);
+	dt_size = fdt32_to_cpu(e->dt_size);
+
+	if (addr)
+		*addr = ((ulong)hdr + dt_offset);
+	if (size)
+		*size = dt_size;
+
+	return true;
+}
+
+#if !defined(CONFIG_SPL_BUILD)
+static void android_dt_print_fdt_info(const struct fdt_header *fdt)
+{
+	u32 fdt_size;
+	int root_node_off;
+	const char *compatible = NULL;
+
+	fdt_size = fdt_totalsize(fdt);
+	root_node_off = fdt_path_offset(fdt, "/");
+	if (root_node_off < 0) {
+		printf("Error: Root node not found\n");
+	} else {
+		compatible = fdt_getprop(fdt, root_node_off, "compatible",
+					 NULL);
+	}
+
+	printf("           (FDT)size = %d\n", fdt_size);
+	printf("     (FDT)compatible = %s\n",
+	       compatible ? compatible : "(unknown)");
+}
+
+/**
+ * Print information about DT image structure.
+ *
+ * @param hdr Address to image header
+ */
+void android_dt_print_contents(const struct dt_table_header *hdr)
+{
+	u32 i;
+	u32 entry_count = fdt32_to_cpu(hdr->dt_entry_count);
+	u32 entries_offset = fdt32_to_cpu(hdr->dt_entries_offset);
+	u32 entry_size = fdt32_to_cpu(hdr->dt_entry_size);
+
+	/* Print image header info */
+	printf("dt_table_header:\n");
+	printf("               magic = %08x\n", fdt32_to_cpu(hdr->magic));
+	printf("          total_size = %d\n", fdt32_to_cpu(hdr->total_size));
+	printf("         header_size = %d\n", fdt32_to_cpu(hdr->header_size));
+	printf("       dt_entry_size = %d\n", entry_size);
+	printf("      dt_entry_count = %d\n", entry_count);
+	printf("   dt_entries_offset = %d\n", entries_offset);
+	printf("           page_size = %d\n", fdt32_to_cpu(hdr->page_size));
+	printf("         reserved[0] = %08x\n", fdt32_to_cpu(hdr->reserved[0]));
+
+	/* Print image entries info */
+	for (i = 0; i < entry_count; ++i) {
+		const struct dt_table_entry *e;
+		const struct fdt_header *fdt;
+		u32 dt_offset, dt_size;
+		u32 j;
+
+		e = (const struct dt_table_entry *)((ulong)hdr + entries_offset
+				+ i * entry_size);
+		dt_offset = fdt32_to_cpu(e->dt_offset);
+		dt_size = fdt32_to_cpu(e->dt_size);
+
+		printf("dt_table_entry[%d]:\n", i);
+		printf("             dt_size = %d\n", dt_size);
+		printf("           dt_offset = %d\n", dt_offset);
+		printf("                  id = %08x\n", fdt32_to_cpu(e->id));
+		printf("                 rev = %08x\n", fdt32_to_cpu(e->rev));
+
+		for (j = 0; j < 4; ++j) {
+			printf("           custom[%d] = %08x\n", j,
+			       fdt32_to_cpu(e->custom[j]));
+		}
+
+		/* Print FDT info for this entry */
+		fdt = (const struct fdt_header *)((ulong)hdr + dt_offset);
+		android_dt_print_fdt_info(fdt);
+	}
+}
+#endif
diff --git a/include/dt_table.h b/include/dt_table.h
new file mode 100644
index 0000000000..19cbbeab2a
--- /dev/null
+++ b/include/dt_table.h
@@ -0,0 +1,46 @@
+/*
+ * This is from the Android Project,
+ * Repository: https://android.googlesource.com/platform/system/libufdt
+ * File: utils/src/dt_table.h
+ * Commit: 58a7582180f477032cd6c74f8d9afad0038e74c3
+ * Copyright (C) 2017 The Android Open Source Project
+ *
+ * SPDX-License-Identifier: BSD-3-Clause
+ */
+
+#ifndef DT_TABLE_H
+#define DT_TABLE_H
+
+#include <linux/types.h>
+
+#define DT_TABLE_MAGIC			0xd7b7ab1e
+#define DT_TABLE_DEFAULT_PAGE_SIZE	2048
+
+struct dt_table_header {
+	u32 magic;		/* DT_TABLE_MAGIC */
+	u32 total_size;		/* includes dt_table_header + all dt_table_entry
+				 * and all dtb/dtbo
+				 */
+	u32 header_size;	/* sizeof(dt_table_header) */
+
+	u32 dt_entry_size;	/* sizeof(dt_table_entry) */
+	u32 dt_entry_count;	/* number of dt_table_entry */
+	u32 dt_entries_offset;	/* offset to the first dt_table_entry
+				 * from head of dt_table_header.
+				 * The value will be equal to header_size if
+				 * no padding is appended
+				 */
+	u32 page_size;		/* flash page size we assume */
+	u32 reserved[1];	/* must be zero */
+};
+
+struct dt_table_entry {
+	u32 dt_size;
+	u32 dt_offset;		/* offset from head of dt_table_header */
+
+	u32 id;			/* optional, must be zero if unused */
+	u32 rev;		/* optional, must be zero if unused */
+	u32 custom[4];		/* optional, must be zero if unused */
+};
+
+#endif
diff --git a/include/image-android-dt.h b/include/image-android-dt.h
new file mode 100644
index 0000000000..f9b5ff3f13
--- /dev/null
+++ b/include/image-android-dt.h
@@ -0,0 +1,18 @@
+/*
+ * (C) Copyright 2018 Linaro Ltd.
+ * Sam Protsenko <semen.protsenko@linaro.org>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+
+#ifndef IMAGE_ANDROID_DT_H
+#define IMAGE_ANDROID_DT_H
+
+#include <dt_table.h>
+
+bool android_dt_check_header(const struct dt_table_header *hdr);
+void android_dt_print_contents(const struct dt_table_header *hdr);
+bool android_dt_get_fdt_by_index(const struct dt_table_header *hdr,
+				 u32 index, ulong *addr, u32 *size);
+
+#endif /* IMAGE_ANDROID_DT_H */